## myMPD-22.1.0.tar.gz

=== CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

# minimal cmake version needed for new option handling
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)
cmake_policy(SET CMP0003 NEW)

# myMPD is written in C
# supported compilers: gcc, clang
project(mympd
  VERSION 22.1.0
  LANGUAGES C
)

# Dependency versions
set(LIBMPDCLIENT_MIN_VERSION "2.24.0")
set(OPENSSL_MIN_VERSION "1.1.0")
set(LUA_MIN_VERSION "5.3.0")

# output binaries in bin directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

message("Cmake version: ${CMAKE_VERSION}")
message("Cmake src dir: ${PROJECT_SOURCE_DIR}")
message("Cmake build dir: ${CMAKE_CURRENT_BINARY_DIR}")
message("Cmake build type: ${CMAKE_BUILD_TYPE}")
message("Cmake generator: ${CMAKE_GENERATOR}")
message("Compiler: ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
message("CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
message("CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
message("Arch: ${CMAKE_C_LIBRARY_ARCHITECTURE}")

# reset cmake default flags
set(CMAKE_C_FLAGS_DEBUG "")
set(CMAKE_C_FLAGS_RELEASE "")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "")
set(CMAKE_C_FLAGS_MINSIZEREL "")

# default is to deliver the assets from htdocs for Debug
# and embedded assets for all other build types
if(NOT DEFINED MYMPD_EMBEDDED_ASSETS)
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(MYMPD_EMBEDDED_ASSETS "OFF")
  else()
    set(MYMPD_EMBEDDED_ASSETS "ON")
  endif()
endif()

# available options
option(MYMPD_BUILD_TESTING "Enables building of unit tests, default OFF" "OFF")
option(MYMPD_DOC "Installs documentation, default ON" "ON")
option(MYMPD_DOC_HTML "Creates and installs the html documentation, default OFF" "OFF")
option(MYMPD_EMBEDDED_ASSETS "Embed assets in binary, default ON, OFF for Debug" "ON")
option(MYMPD_EMBEDDED_LIBMPDCLIENT "Use embedded libmpdclient, default OFF" "OFF")
option(MYMPD_ENABLE_EXPERIMENTAL "Enable experimental features, default OFF" "OFF")
option(MYMPD_ENABLE_FLAC "Enables flac support, default ON" "ON")
option(MYMPD_ENABLE_IPV6 "Enables IPv6, default ON" "ON")
option(MYMPD_ENABLE_LIBID3TAG "Enables libid3tag support, default ON" "ON")
option(MYMPD_ENABLE_LUA "Enables lua support, default ON" "ON")
option(MYMPD_ENABLE_MYGPIOD "Enables myGPIOd support, default ON" "ON")
option(MYMPD_MANPAGES "Creates and installs manpages, default ON" "ON")
option(MYMPD_MINIMAL "Enables minimal myMPD build, disables all MYMPD_ENABLE_* flags, default OFF" "OFF")
option(MYMPD_STARTUP_SCRIPT "Installs the startup script, default ON" "ON")
# sanitizer options
option(MYMPD_ENABLE_ASAN "Enables build with address sanitizer, default OFF" "OFF")
option(MYMPD_ENABLE_TSAN "Enables build with thread sanitizer, default OFF" "OFF")
option(MYMPD_ENABLE_UBSAN "Enables build with undefined behavior sanitizer, default OFF" "OFF")

if(MYMPD_MINIMAL)
  set(MYMPD_ENABLE_FLAC "OFF")
  set(MYMPD_ENABLE_IPV6 "OFF")
  set(MYMPD_ENABLE_LUA "OFF")
  set(MYMPD_ENABLE_LIBID3TAG "OFF")
  set(MYMPD_ENABLE_MYGPIOD "OFF")
endif()

if(MYMPD_ENABLE_EXPERIMENTAL)
  message("Experimental features enabled")
endif()

# cmake modules
include(CheckCCompilerFlag)
include(CheckCSourceCompiles)
include(CheckIPOSupported)
include(GNUInstallDirs)

# custom cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/")

# required dependencies
find_package(Threads REQUIRED)
find_package(PCRE2 REQUIRED)
find_library(MATH_LIB m REQUIRED)
find_package(OpenSSL REQUIRED)

if(MYMPD_EMBEDDED_LIBMPDCLIENT STREQUAL "ON")
  message("Using embedded libmpdclient")
else()
  find_package(LIBMPDCLIENT)
  if(LIBMPDCLIENT_FOUND)
    if(LIBMPDCLIENT_VERSION VERSION_LESS "${LIBMPDCLIENT_MIN_VERSION}")
      message(WARNING "libmpdclient ${LIBMPDCLIENT_VERSION} is too old, minimum version is ${LIBMPDCLIENT_MIN_VERSION}")
      message("Using embedded libmpdclient")
      set(MYMPD_EMBEDDED_LIBMPDCLIENT "ON")
    else()
      message("Using shared libmpdclient ${LIBMPDCLIENT_VERSION}")
      set(MYMPD_EMBEDDED_LIBMPDCLIENT "OFF")
    endif()
  else()
    message("libmpdclient not found, using embedded libmpdclient")
    set(MYMPD_EMBEDDED_LIBMPDCLIENT "ON")
  endif()
endif()

# set myMPD specific debug define
if(MYMPD_EMBEDDED_LIBMPDCLIENT)
  add_compile_options(
    "-DMYMPD_EMBEDDED_LIBMPDCLIENT=1"
  )
endif()

# check dependencies versions
if(OPENSSL_VERSION VERSION_LESS "${OPENSSL_MIN_VERSION}")
  message(FATAL_ERROR "myMPD requires an OpenSSL version greater or equal ${OPENSSL_MIN_VERSION}")
endif()

# optional dependencies
if(MYMPD_ENABLE_LIBID3TAG)
  message("Searching for libid3tag")
  find_package(LIBID3TAG)
  if(NOT LIBID3TAG_FOUND)
    message(WARNING "Libid3tag is disabled because it was not found")
    set(MYMPD_ENABLE_LIBID3TAG "OFF")
  endif()
else()
  message("Libid3tag is disabled by user")
endif()

if(MYMPD_ENABLE_FLAC)
  message("Searching for flac")
  find_package(FLAC)
  if(NOT FLAC_FOUND)
    message(WARNING "Flac is disabled because it was not found")
    set(MYMPD_ENABLE_FLAC "OFF")
  endif()
else()
  message("Flac is disabled by user")
endif()

if(MYMPD_ENABLE_LUA)
  if(EXISTS "/etc/alpine-release")
    set(ENV{LUA_DIR} "/usr/lib/lua5.4")
  endif()
  message("Searching for lua")
  find_package(Lua)
  if(LUA_FOUND)
    if(NOT LUA_VERSION_STRING VERSION_GREATER_EQUAL "${LUA_MIN_VERSION}")
      message(WARNING "Lua is disabled because a version lower than ${LUA_MIN_VERSION} was found")
      set(MYMPD_ENABLE_LUA "OFF")
      set(MYMPD_ENABLE_MYGPIOD "OFF")
    endif()
  else()
    message(WARNING "Lua is disabled because it was not found")
    set(MYMPD_ENABLE_LUA "OFF")
    set(MYMPD_ENABLE_MYGPIOD "OFF")
  endif()
else()
  message("Lua is disabled by user")
  set(MYMPD_ENABLE_MYGPIOD "OFF")
endif()

if(MYMPD_ENABLE_MYGPIOD)
  message("Searching for libmygpio")
  find_package(LIBMYGPIO)
  if(NOT LIBMYGPIO_FOUND)
    message("Compiling static version of libmygpio")
    set(MYMPD_ENABLE_MYGPIOD_STATIC "ON")
  endif()
else()
  message("myGPIO support is disabled by user")
endif()

# calculate paths
if(CMAKE_INSTALL_PREFIX MATCHES "/usr")
  set(SUBDIR "/${PROJECT_NAME}")
  set(SUBDIRLIB "/lib")
  set(SUBDIRCACHE "/cache")
else()
  # for install in /opt
  set(SUBDIR "")
  set(SUBDIRLIB "")
  set(SUBDIRCACHE "")
endif()

message("Executables in: ${CMAKE_INSTALL_FULL_BINDIR}")

if(CMAKE_INSTALL_PREFIX STREQUAL "/usr/local")
  set(MYMPD_WORK_DIR "/${CMAKE_INSTALL_LOCALSTATEDIR}${SUBDIRLIB}${SUBDIR}")
  set(MYMPD_CACHE_DIR "/${CMAKE_INSTALL_LOCALSTATEDIR}${SUBDIRCACHE}${SUBDIR}")
else()
  set(MYMPD_WORK_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}${SUBDIRLIB}${SUBDIR}")
  set(MYMPD_CACHE_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}${SUBDIRCACHE}${SUBDIR}")
endif()

message("Workdir: ${MYMPD_WORK_DIR}")
message("Cachedir: ${MYMPD_CACHE_DIR}")

# create assets and set doc root
set(ENV{MYMPD_BUILDDIR} "${CMAKE_CURRENT_BINARY_DIR}")
set(ENV{MYMPD_ENABLE_MYGPIOD} "${MYMPD_ENABLE_MYGPIOD}")
set(ENV{MYMPD_ENABLE_LUA} "${MYMPD_ENABLE_LUA}")

if(MYMPD_EMBEDDED_ASSETS)
  message("Embedding assets in binary")
  set(MYMPD_DOC_ROOT "${MYMPD_WORK_DIR}/empty")
  set(MYMPD_LUALIBS_PATH "")
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" createassets RESULT_VARIABLE RC_CREATE_ASSETS)
  # remove object files with embedded assets
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/webserver/utility.c.o")
  file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/src/CMakeFiles/mympd.dir/mympd_api/scripts.c.o")
else()
  message("Serving assets from filesystem")
  set(MYMPD_DOC_ROOT "${PROJECT_SOURCE_DIR}/htdocs")
  set(MYMPD_LUALIBS_PATH "${CMAKE_CURRENT_BINARY_DIR}/contrib/lualibs")
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" copyassets RESULT_VARIABLE RC_CREATE_ASSETS)
endif()

if(RC_CREATE_ASSETS GREATER 0)
  message(FATAL_ERROR "Creating assets failed")
endif()

message("Document root: ${MYMPD_DOC_ROOT}")
message("Docdir: ${CMAKE_INSTALL_FULL_DOCDIR}")

# translation files
if(MYMPD_EMBEDDED_ASSETS)
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/bg-BG.json.gz")
    set(I18N_bg_BG "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/de-DE.json.gz")
    set(I18N_de_DE "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/en-US.json.gz")
    set(I18N_en_US "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-AR.json.gz")
    set(I18N_es_AR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-ES.json.gz")
    set(I18N_es_ES "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/es-VE.json.gz")
    set(I18N_es_VE "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/fi-FI.json.gz")
    set(I18N_fi_FI "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/fr-FR.json.gz")
    set(I18N_fr_FR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/it-IT.json.gz")
    set(I18N_it_IT "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ja-JP.json.gz")
    set(I18N_ja_JP "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ko-KR.json.gz")
    set(I18N_ko_KR "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/nl-NL.json.gz")
    set(I18N_nl_NL "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/pl-PL.json.gz")
    set(I18N_pl_PL "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/ru-RU.json.gz")
    set(I18N_ru_RU "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/zh-Hans.json.gz")
    set(I18N_zh_Hans "ON")
  endif()
  if(EXISTS "${PROJECT_BINARY_DIR}/htdocs/assets/i18n/zh-Hant.json.gz")
    set(I18N_zh_Hant "ON")
  endif()
endif()

# create html documentation
if(MYMPD_DOC_HTML)
  execute_process(COMMAND "${PROJECT_SOURCE_DIR}/build.sh" doc "${PROJECT_BINARY_DIR}/htmldoc" RESULT_VARIABLE RC_CREATE_DOC)
endif()
if(RC_CREATE_DOC GREATER 0)
  message(FATAL_ERROR "Creating documentation failed")
endif()

# configure some files - version and path information
configure_file(src/compile_time.h.in "${PROJECT_BINARY_DIR}/compile_time.h")
configure_file(src/webserver/embedded_files.c.in "${PROJECT_BINARY_DIR}/embedded_files.c")
configure_file(src/scripts/lualibs.c.in "${PROJECT_BINARY_DIR}/lualibs.c")
configure_file(cmake/Install.cmake.in cmake/Install.cmake @ONLY)
configure_file(contrib/initscripts/mympd.service.system.in contrib/initscripts/system/mympd.service @ONLY)
configure_file(contrib/initscripts/mympd.service.user.in contrib/initscripts/user/mympd.service @ONLY)
configure_file(contrib/initscripts/mympd.sysVinit.in contrib/initscripts/mympd.sysVinit @ONLY)
configure_file(contrib/initscripts/mympd.openrc.in contrib/initscripts/mympd.openrc @ONLY)
configure_file(contrib/initscripts/mympd.freebsdrc.in contrib/initscripts/mympd.freebsdrc @ONLY)

# global compile options
add_compile_options(
  "-DMPACK_HAS_CONFIG=1"
  "-DMG_MAX_HTTP_HEADERS=50"
)

# set myMPD specific debug define
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_compile_options(
    "-DMYMPD_DEBUG=ON"
  )
endif()

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  set(C_OPTS
    "-D_GLIBCXX_ASSERTIONS"
    "-D_LIBCXX_ENABLE_ASSERTIONS"
    "-fcf-protection=full"
    "-fdata-sections"
    "-ffunction-sections"
    "-fno-delete-null-pointer-checks"
    "-fno-omit-frame-pointer"
    "-fno-plt"
    "-fno-strict-aliasing"
    "-fno-strict-overflow"
    "-fstack-clash-protection"
    "-fstack-protector-strong"
    "-fstrict-flex-arrays=3"
    "-ftrivial-auto-var-init=zero"
    "-mbranch-protection=standard"
    "-mno-omit-leaf-frame-pointer"
    "-mshstk"
    "-pedantic"
    "-std=gnu17"
    "-Wall"
    "-Werror"
    "-Wextra"
    "-Wformat=2"
    "-Wformat-security"
    "-Winit-self"
    "-Wmissing-include-dirs"
    "-Wnested-externs"
    "-Wold-style-definition"
    "-Wredundant-decls"
    "-Wshadow"
    "-Wsign-compare"
    "-Wstrict-prototypes"
    "-Wundef"

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_executable(mympd "")

if(CMAKE_BUILD_TYPE MATCHES "(Release|Debug)")
  target_compile_options(mympd
    PRIVATE
      "-Wconversion"
      "-Wformat=2"
  )
endif()

target_include_directories(mympd
  PRIVATE 
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}
    ${OPENSSL_INCLUDE_DIR}
)

target_include_directories(mympd SYSTEM PRIVATE ${PCRE2_INCLUDE_DIRS})

if(MYMPD_ENABLE_LIBID3TAG)
  target_include_directories(mympd SYSTEM PRIVATE ${LIBID3TAG_INCLUDE_DIRS})
endif()
if(MYMPD_ENABLE_FLAC)
  target_include_directories(mympd SYSTEM PRIVATE ${FLAC_INCLUDE_DIRS})
endif()
if(MYMPD_ENABLE_LUA)
  target_include_directories(mympd SYSTEM PRIVATE ${LUA_INCLUDE_DIR})
endif()
if(MYMPD_ENABLE_MYGPIOD)
  if(MYMPD_ENABLE_MYGPIOD_STATIC)
    target_include_directories(mympd SYSTEM PRIVATE "${PROJECT_SOURCE_DIR}/dist/myGPIOd/libmygpio/include")
  else()
    target_include_directories(mympd SYSTEM PRIVATE ${LIBMYGPIO_INCLUDE_DIRS})
  endif()
endif()
if(NOT MYMPD_EMBEDDED_LIBMPDCLIENT)
  target_include_directories(mympd SYSTEM PRIVATE ${LIBMPDCLIENT_INCLUDE_DIRS})
endif()

target_sources(mympd
  PRIVATE
    main.c
    lib/album.c
    lib/api.c
    lib/cacertstore.c
    lib/cache/cache_disk_images.c
    lib/cache/cache_disk_lyrics.c
    lib/cache/cache_disk.c
    lib/cache/cache_rax_album.c
    lib/cache/cache_rax.c
    lib/cert.c
    lib/config.c
    lib/convert.c
    lib/datetime.c
    lib/env.c
    lib/event.c
    lib/fields.c
    lib/filehandler.c
    lib/handle_options.c
    lib/http_client.c
    lib/http_client_cache.c
    lib/json/json_print.c
    lib/json/json_query.c
    lib/json/json_rpc.c
    lib/jukebox.c
    lib/last_played.c
    lib/list.c
    lib/log.c
    lib/mimetype.c
    lib/mpack.c
    lib/passwd.c
    lib/pin.c
    lib/msg_queue.c
    lib/mympd_state.c
    lib/random.c
    lib/rax_extras.c
    lib/search.c
    lib/sds_extras.c
    lib/signal.c
    lib/smartpls.c
    lib/sticker.c
    lib/state_files.c
    lib/thread.c
    lib/timer.c
    lib/utility.c
    lib/validate.c
    lib/webradio.c
    mympd_client/autoconf.c
    mympd_client/compat.c
    mympd_client/connection.c
    mympd_client/errorhandler.c
    mympd_client/features.c
    mympd_client/idle.c
    mympd_client/jukebox.c
    mympd_client/partitions.c
    mympd_client/playlists.c
    mympd_client/queue.c
    mympd_client/presets.c
    mympd_client/random_select.c
    mympd_client/search.c
    mympd_client/stickerdb.c
    mympd_client/shortcuts.c
    mympd_client/tags.c
    mympd_client/volume.c
    mympd_worker/mympd_worker.c
    mympd_worker/album_cache.c
    mympd_worker/api.c
    mympd_worker/jukebox.c
    mympd_worker/playlists.c
    mympd_worker/random_select.c
    mympd_worker/smartpls.c
    mympd_worker/state.c
    mympd_worker/song.c
    mympd_worker/webradiodb.c
    mympd_api/mympd_api.c
    mympd_api/albumart.c
    mympd_api/albums.c
    mympd_api/channel.c
    mympd_api/database.c
    mympd_api/extra_media.c
    mympd_api/filesystem.c
    mympd_api/folderart.c
    mympd_api/home.c
    mympd_api/jukebox.c
    mympd_api/last_played.c
    mympd_api/lyrics.c
    mympd_api/mounts.c
    mympd_api/mympd_api_handler.c
    mympd_api/outputs.c
    mympd_api/partitions.c
    mympd_api/pictures.c
    mympd_api/playlistart.c
    mympd_api/playlists.c
    mympd_api/queue.c
    mympd_api/requests.c
    mympd_api/search.c
    mympd_api/settings.c
    mympd_api/smartpls.c
    mympd_api/song.c
    mympd_api/stats.c
    mympd_api/status.c
    mympd_api/sticker.c
    mympd_api/tagart.c
    mympd_api/tags.c
    mympd_api/timer.c
    mympd_api/timer_handlers.c
    mympd_api/trigger.c
    mympd_api/volume.c
    mympd_api/webradio.c
    mympd_api/webradio_favorites.c
    webserver/webserver.c
    webserver/albumart.c
    webserver/folderart.c
    webserver/mg_user_data.c
    webserver/request_handler.c
    webserver/placeholder.c
    webserver/proxy.c
    webserver/sessions.c
    webserver/playlistart.c
    webserver/tagart.c
    webserver/utility.c
    webserver/webradio.c
)

if(MYMPD_ENABLE_LUA)
  target_sources(mympd
    PRIVATE
      mympd_api/lua_mympd_state.c
      scripts/api_handler.c
      scripts/api_scripts.c
      scripts/api_tmp.c
      scripts/api_vars.c
      scripts/events.c
      scripts/interface_caches.c
      scripts/interface_http.c
      scripts/interface_mympd_api.c
      scripts/interface_util.c
      scripts/interface.c
      scripts/scripts_lua.c
      scripts/scripts_worker.c
      scripts/scripts.c
      scripts/util.c
      scripts/verify.c
      webserver/scripts.c
  )
endif()

if(MYMPD_ENABLE_FLAC)
  target_sources(mympd
    PRIVATE
      mympd_api/lyrics_flac.c
      webserver/albumart_flac.c
  )
endif()

if(MYMPD_ENABLE_LIBID3TAG)
  target_sources(mympd
    PRIVATE
      mympd_api/lyrics_id3.c
      webserver/albumart_id3.c
  )
endif()

if(MYMPD_ENABLE_MYGPIOD)
  target_sources(mympd
    PRIVATE
      scripts/interface_mygpio.c
  )
endif()

=== test/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

set(MYMPD_BUILD_DIR "${PROJECT_BINARY_DIR}")
configure_file(utility.h.in "${PROJECT_BINARY_DIR}/test/utility.h")

set(TEST_SOURCES
  main.c
  utility.c
  ../src/lib/album.c
  ../src/lib/api.c
  ../src/lib/cacertstore.c
  ../src/lib/cache/cache_disk_lyrics.c
  ../src/lib/cache/cache_rax_album.c
  ../src/lib/cache/cache_rax.c
  ../src/lib/cert.c
  ../src/lib/config.c
  ../src/lib/convert.c
  ../src/lib/datetime.c
  ../src/lib/event.c
  ../src/lib/env.c
  ../src/lib/fields.c
  ../src/lib/filehandler.c
  ../src/lib/http_client.c
  ../src/lib/http_client_cache.c
  ../src/lib/json/json_print.c
  ../src/lib/json/json_query.c
  ../src/lib/json/json_rpc.c
  ../src/lib/jukebox.c
  ../src/lib/last_played.c
  ../src/lib/list.c
  ../src/lib/log.c
  ../src/lib/mimetype.c
  ../src/lib/mpack.c
  ../src/lib/msg_queue.c
  ../src/lib/mympd_state.c
  ../src/lib/passwd.c
  ../src/lib/random.c
  ../src/lib/rax_extras.c
  ../src/lib/sds_extras.c
  ../src/lib/search.c
  ../src/lib/smartpls.c
  ../src/lib/state_files.c
  ../src/lib/sticker.c
  ../src/lib/timer.c
  ../src/lib/utility.c
  ../src/lib/validate.c
  ../src/lib/webradio.c
  ../src/mympd_client/compat.c
  ../src/mympd_client/connection.c
  ../src/mympd_client/errorhandler.c
  ../src/mympd_client/features.c
  ../src/mympd_client/jukebox.c
  ../src/mympd_client/presets.c
  ../src/mympd_client/queue.c
  ../src/mympd_client/playlists.c
  ../src/mympd_client/random_select.c
  ../src/mympd_client/search.c
  ../src/mympd_client/shortcuts.c
  ../src/mympd_client/stickerdb.c
  ../src/mympd_client/tags.c
  ../src/mympd_client/jukebox.c
  ../src/mympd_client/volume.c
  ../src/mympd_api/extra_media.c
  ../src/mympd_api/home.c
  ../src/mympd_api/last_played.c
  ../src/mympd_api/jukebox.c
  ../src/mympd_api/lua_mympd_state.c
  ../src/mympd_api/lyrics.c
  ../src/mympd_api/requests.c
  ../src/mympd_api/settings.c
  ../src/mympd_api/status.c
  ../src/mympd_api/sticker.c
  ../src/mympd_api/timer.c
  ../src/mympd_api/timer_handlers.c
  ../src/mympd_api/trigger.c
  ../src/mympd_api/queue.c
  ../src/mympd_api/webradio.c
  ../src/scripts/events.c
  ../src/webserver/mg_user_data.c
  tests/test_album_cache.c
  tests/test_api.c
  tests/test_cert.c
  tests/test_convert.c
  tests/test_datetime.c
  tests/test_env.c
  tests/test_filehandler.c
  tests/test_http_client.c
  tests/test_http_client_cache.c
  tests/test_jsonprint.c
  tests/test_jsonquery.c
  tests/test_list.c
  tests/test_mimetype.c
  tests/test_mympd_queue.c
  tests/test_mympd_state.c
  tests/test_radix_sort.c
  tests/test_random.c
  tests/test_sds_extras.c
  tests/test_search.c
  tests/test_state_files.c
  tests/test_tags.c
  tests/test_timer.c
  tests/test_utility.c
  tests/test_validate.c
)

if(LIBID3TAG_FOUND)
  set(TEST_SOURCES_LIBID3TAG
    ../src/mympd_api/lyrics_id3.c
    tests/test_lyrics_id3.c
  )
endif()
if(FLAC_FOUND)
  set(TEST_SOURCES_FLAC
  ../src/mympd_api/lyrics_flac.c
    tests/test_lyrics_flac.c
  )
endif()

add_executable(unit_test
  ${TEST_SOURCES}
  ${TEST_SOURCES_LIBID3TAG}
  ${TEST_SOURCES_FLAC}
)

target_include_directories(unit_test
  PRIVATE 
    ${PROJECT_BINARY_DIR}
    ${PROJECT_BINARY_DIR}/test
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/test
)

target_compile_options(unit_test
  PRIVATE
    "-Wno-unused-function"
    "-Wno-redundant-decls"
    "-DMG_MAX_HTTP_HEADERS=50"
)

target_link_libraries(unit_test
  mpack
  mongoose
  rax
  sds
  ${CMAKE_THREAD_LIBS_INIT}
  ${MATH_LIB}
  ${OPENSSL_LIBRARIES}
  ${PCRE2_LIBRARIES}
)

if(MYMPD_EMBEDDED_LIBMPDCLIENT)
  target_link_libraries(unit_test mpdclient)
else()
  target_link_libraries(unit_test ${LIBMPDCLIENT_LIBRARIES})
endif()

# link optional dependencies
if(LIBID3TAG_FOUND)
  target_link_libraries(unit_test ${LIBID3TAG_LIBRARIES})
endif()
if(FLAC_FOUND)
  target_link_libraries(unit_test ${FLAC_LIBRARIES})
endif()

add_custom_command(TARGET unit_test PRE_BUILD
  COMMAND ${CMAKE_COMMAND} -E create_symlink
  ${CMAKE_SOURCE_DIR}/test/testfiles ${PROJECT_BINARY_DIR}/testfiles)

# define tests
list(APPEND test_categories
  "album_cache"
  "api"
  "cert"
  "convert"
  "datetime"
  "env"
  "filehandler"
  "http_client"
  "jsonprint"
  "jsonquery"
  "list"
  "m3u"
  "mimetype"
  "mympd_queue"
  "mympd_state"
  "passwd"
  "radix_sort"
  "random"
  "sds_extras"
  "search_local"
  "state_files"
  "tags"
  "timer"
  "utility"
  "validate"
)

if(LIBID3TAG_FOUND)
  list(APPEND test_categories "lyrics_id3")
endif()
if(FLAC_FOUND)
  list(APPEND test_categories "lyrics_flac")
endif()

foreach(CAT IN LISTS test_categories)
  add_test(NAME "test_${CAT}" COMMAND "unit_test" "--filter=${CAT}.*")
endforeach()

=== dist/libmpdclient/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mpdclient "")

target_include_directories(mpdclient PUBLIC include)

if(CMAKE_BUILD_TYPE MATCHES "(Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(mpdclient
    PRIVATE
      "-DNDEBUG"
  )
endif()

target_sources(mpdclient
  PRIVATE
    src/albumart.c
    src/async.c
    src/audio_format.c
    src/binary.c
    src/capabilities.c
    src/cmessage.c
    src/cmount.c
    src/cneighbor.c
    src/connection.c
    src/coutput.c
    src/cpartition.c
    src/cplaylist.c
    src/cstats.c
    src/cstatus.c
    src/database.c
    src/directory.c
    src/entity.c
    src/error.c
    src/fd_util.c
    src/feature.c
    src/fingerprint.c
    src/idle.c
    src/ierror.c
    src/iso8601.c
    src/kvlist.c
    src/list.c
    src/message.c
    src/mixer.c
    src/mount.c
    src/neighbor.c
    src/output.c
    src/parser.c
    src/partition.c
    src/password.c
    src/player.c
    src/playlist.c
    src/position.c
    src/queue.c
    src/quote.c
    src/replay_gain.c
    src/rdirectory.c
    src/readpicture.c
    src/recv.c
    src/replay_gain.c
    src/resolver.c
    src/response.c
    src/rplaylist.c
    src/run.c
    src/request.c
    src/search.c
    src/send.c
    src/settings.c
    src/socket.c
    src/song.c
    src/stats.c
    src/status.c
    src/sticker.c
    src/sync.c
    src/tag.c
    src/stringnormalization.c
)

=== dist/mpack/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(mpack "")

target_sources(mpack
  PRIVATE
    mpack.c
    mpack-config.h
  PUBLIC
    mpack.h
)

target_include_directories(mpack
  PRIVATE
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_BINARY_DIR}
)

=== dist/rax/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

add_library(rax "")

target_sources(rax
  PRIVATE
    rax.c
    rax_malloc.h
  PUBLIC
    rax.h
)

target_include_directories(rax
  PRIVATE
    ${PROJECT_SOURCE_DIR}
)

if(CMAKE_BUILD_TYPE MATCHES "(Debug|Release|RelWithDebInfo|MinSizeRel)")
  target_compile_options(rax
    PRIVATE
      "-Wno-shadow"
      "-Wno-incompatible-pointer-types-discards-qualifiers"
      "-Wformat"
  )

  if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    target_compile_options(rax
      PRIVATE
        "-Wno-discarded-qualifiers"
        "-Wno-use-after-free"
    )
  endif()
endif()

=== contrib/packaging/openwrt/Makefile ===
#
# Copyright (C) 2021-2023 Tomasz Maciej Nowak <tmn505@gmail.com>
#
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd

include $(TOPDIR)/rules.mk

PKG_NAME := mympd
PKG_VERSION := 22.1.0
PKG_RELEASE := 1

PKG_SOURCE := $(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_SOURCE_URL := https://codeload.github.com/jcorporation/myMPD/tar.gz/refs/tags/v$(PKG_VERSION)?
PKG_HASH := skip

PKG_LICENSE := GPL-3.0
PKG_LICENSE_FILE := LICENSE.md

PKG_MAINTAINER := Juergen Mang <mail [at] jcgames [dot] de>

PKG_BUILD_DIR := $(BUILD_DIR)/myMPD-$(PKG_VERSION)
PKG_BUILD_FLAGS := no-mips16
PKG_BUILD_PARALLEL := 1
PKG_ASLR_PIE_REGULAR := 1
PKG_FORTIFY_SOURCE := 0
PKG_USE_NINJA := 0
PKG_CONFIG_DEPENDS := \
    CONFIG_MYMPD_FLAC \
    CONFIG_MYMPD_ID3TAG \
    CONFIG_MYMPD_LUA

CMAKE_BINARY_SUBDIR := release

include $(INCLUDE_DIR)/package.mk
include $(INCLUDE_DIR)/cmake.mk

define Package/mympd
  SECTION := sound
  CATEGORY := Sound
  TITLE := myMPD - web MPD client and more
  URL := https://jcorporation.github.io
  DEPENDS := +libpcre2 +MYMPD_FLAC:libflac +MYMPD_ID3TAG:libid3tag +MYMPD_LUA:liblua5.3 +libopenssl
  USERID := mympd:mympd
endef

define Package/mympd/description
Standalone and mobile friendly web MPD client with a tiny footprint and advanced features.
endef

define Package/mympd/config
    if PACKAGE_mympd

        config MYMPD_FLAC
            bool "Extracting cover images from FLAC files"
            default y

        config MYMPD_ID3TAG
            bool "Extracting cover images from ID3 tags"
            default y

        config MYMPD_LUA
            bool "LUA scripts support"
            default n

    endif
endef

CMAKE_OPTIONS += \
    -DMYMPD_ENABLE_FLAC=$(if $(CONFIG_MYMPD_FLAC),ON,OFF) \
    -DMYMPD_ENABLE_LIBID3TAG=$(if $(CONFIG_MYMPD_ID3TAG),ON,OFF) \
    -DMYMPD_ENABLE_LUA=$(if $(CONFIG_MYMPD_LUA),ON,OFF)

define Package/mympd/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/mympd $(1)/usr/bin/
    $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/mympd-config $(1)/usr/bin/
	$(if $(CONFIG_MYMPD_LUA),$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/mympd-script $(1)/usr/bin/)

	$(INSTALL_DIR) $(1)/etc/config
	$(INSTALL_CONF) ./files/mympd.config $(1)/etc/config/mympd
	$(INSTALL_DIR) $(1)/etc/init.d
	$(INSTALL_BIN) ./files/mympd.init $(1)/etc/init.d/mympd
endef

$(eval $(call BuildPackage,mympd))

=== contrib/packaging/freebsd/multimedia/mympd/Makefile ===
PORTNAME=	myMPD
DISTVERSIONPREFIX= v
DISTVERSION=	22.1.0
CATEGORIES=	multimedia

MAINTAINER=	robert.david@posteo.net
COMMENT=	Standalone and mobile friendly web-based MPD client
WWW=		https://github.com/jcorporation/myMPD

LICENSE=	GPLv3+

BUILD_DEPENDS=	jq:textproc/jq
LIB_DEPENDS=	libpcre2-8.so:devel/pcre2 \
		libid3tag.so:audio/libid3tag \
		libFLAC.so:audio/flac \
		libogg.so:audio/libogg \
		liblua-5.4.so:lang/lua54

USES=		cmake:noninja perl5
USE_PERL5=	build
USE_GITHUB=	yes
GH_ACCOUNT=	jcorporation

.include <bsd.port.mk>

=== contrib/packaging/debian/changelog ===
mympd (22.1.0-1) unstable; urgency=medium

  * Release from master

 -- Juergen Mang <mail@jcgames.de>  Wed, 01 Oct 2025 19:10:47 +0200

=== contrib/packaging/alpine/APKBUILD ===
#
# SPDX-License-Identifier: GPL-3.0-or-later
# myMPD (c) 2018-2025 Juergen Mang <mail@jcgames.de>
# https://github.com/jcorporation/mympd
#
# Maintainer: Juergen Mang <mail@jcgames.de>
#
pkgname=mympd
pkgver=22.1.0
pkgrel=0
pkgdesc="myMPD is a standalone and mobile friendly web-based MPD client."
url="https://jcorporation.github.io/myMPD/"
arch="all"
license="GPL-3.0-or-later"
depends="newt"
makedepends="
	cmake
	flac-dev
	gzip
	jq
	lua5.4
	lua5.4-dev
	libid3tag-dev
	linux-headers
	openssl-dev
	pcre2-dev
	perl
	"
install="$pkgname.pre-install"
subpackages="$pkgname-dbg $pkgname-doc"
source="mympd_$pkgver.orig.tar.gz"
builddir="$srcdir"
options="!check"
#no test suite

build() {
	cmake -B "$builddir/release" -DCMAKE_INSTALL_PREFIX:PATH=/usr -DCMAKE_BUILD_TYPE=RelWithDebInfo "$builddir"
	make -C "$builddir/release"
}

package() {
	make -C "$builddir/release" DESTDIR="$pkgdir" install
}

=== contrib/packaging/arch/PKGBUILD ===
# Maintainer: Juergen Mang <mail@jcgames.de>

pkgname=mympd
pkgver=22.1.0
pkgrel=1
pkgdesc="A standalone and mobile friendly web-based MPD client."
arch=('i686' 'x86_64' 'armv6h' 'armv7h' 'aarch64')
url="https://jcorporation.github.io/myMPD/"
license=(GPL3)
depends=('flac' 'libid3tag' 'lua' 'openssl' 'pcre2' 'libnewt')
makedepends=('cmake' 'gzip' 'jq' 'perl')
source=("${pkgname}_${pkgver}.orig.tar.gz")
sha256sums=('SKIP')
options=(debug strip)

build() {
  local cmake_options=(
    -B build
    -S "${srcdir}"
    -DCMAKE_BUILD_TYPE=RelWithDebInfo
    -DCMAKE_INSTALL_PREFIX=/usr
    -Wno-dev
  )

  cmake "${cmake_options[@]}"
  cmake --build build
}

package() {
  DESTDIR="$pkgdir" cmake --install build
}
